/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BREAKPOINT_20060720_H_
#define BREAKPOINT_20060720_H_

#include <QByteArray>
#include <QString>
#include "Types.h"

class Breakpoint {
public:
	virtual ~Breakpoint() {}
	
public:
	virtual edb::address_t address() const = 0;
	virtual unsigned int hitCount() const = 0;
	virtual bool enabled() const = 0;
	virtual bool oneTime() const = 0;
	virtual bool internal() const = 0;
	virtual QByteArray originalBytes() const = 0;

public:
	virtual bool enable() = 0;
	virtual bool disable() = 0;
	virtual void hit() = 0;
	virtual void setOneTime(bool value) = 0;
		
public:
	QString condition;
};

#endif
